// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from autoware_auto_msgs:msg/ControlDiagnostic.idl
// generated code does not contain a copyright notice
#include "autoware_auto_msgs/msg/detail/control_diagnostic__rosidl_typesupport_fastrtps_cpp.hpp"
#include "autoware_auto_msgs/msg/detail/control_diagnostic__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace autoware_auto_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const autoware_auto_msgs::msg::DiagnosticHeader &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  autoware_auto_msgs::msg::DiagnosticHeader &);
size_t get_serialized_size(
  const autoware_auto_msgs::msg::DiagnosticHeader &,
  size_t current_alignment);
size_t
max_serialized_size_DiagnosticHeader(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace autoware_auto_msgs


namespace autoware_auto_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_autoware_auto_msgs
cdr_serialize(
  const autoware_auto_msgs::msg::ControlDiagnostic & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: diag_header
  autoware_auto_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.diag_header,
    cdr);
  // Member: new_trajectory
  cdr << (ros_message.new_trajectory ? true : false);
  // Member: trajectory_source
  cdr << ros_message.trajectory_source;
  // Member: pose_source
  cdr << ros_message.pose_source;
  // Member: lateral_error_m
  cdr << ros_message.lateral_error_m;
  // Member: longitudinal_error_m
  cdr << ros_message.longitudinal_error_m;
  // Member: velocity_error_mps
  cdr << ros_message.velocity_error_mps;
  // Member: acceleration_error_mps2
  cdr << ros_message.acceleration_error_mps2;
  // Member: yaw_error_rad
  cdr << ros_message.yaw_error_rad;
  // Member: yaw_rate_error_rps
  cdr << ros_message.yaw_rate_error_rps;
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_autoware_auto_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  autoware_auto_msgs::msg::ControlDiagnostic & ros_message)
{
  // Member: diag_header
  autoware_auto_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.diag_header);

  // Member: new_trajectory
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.new_trajectory = tmp ? true : false;
  }

  // Member: trajectory_source
  cdr >> ros_message.trajectory_source;

  // Member: pose_source
  cdr >> ros_message.pose_source;

  // Member: lateral_error_m
  cdr >> ros_message.lateral_error_m;

  // Member: longitudinal_error_m
  cdr >> ros_message.longitudinal_error_m;

  // Member: velocity_error_mps
  cdr >> ros_message.velocity_error_mps;

  // Member: acceleration_error_mps2
  cdr >> ros_message.acceleration_error_mps2;

  // Member: yaw_error_rad
  cdr >> ros_message.yaw_error_rad;

  // Member: yaw_rate_error_rps
  cdr >> ros_message.yaw_rate_error_rps;

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_autoware_auto_msgs
get_serialized_size(
  const autoware_auto_msgs::msg::ControlDiagnostic & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: diag_header

  current_alignment +=
    autoware_auto_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.diag_header, current_alignment);
  // Member: new_trajectory
  {
    size_t item_size = sizeof(ros_message.new_trajectory);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: trajectory_source
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.trajectory_source.size() + 1);
  // Member: pose_source
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.pose_source.size() + 1);
  // Member: lateral_error_m
  {
    size_t item_size = sizeof(ros_message.lateral_error_m);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: longitudinal_error_m
  {
    size_t item_size = sizeof(ros_message.longitudinal_error_m);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: velocity_error_mps
  {
    size_t item_size = sizeof(ros_message.velocity_error_mps);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: acceleration_error_mps2
  {
    size_t item_size = sizeof(ros_message.acceleration_error_mps2);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: yaw_error_rad
  {
    size_t item_size = sizeof(ros_message.yaw_error_rad);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: yaw_rate_error_rps
  {
    size_t item_size = sizeof(ros_message.yaw_rate_error_rps);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_autoware_auto_msgs
max_serialized_size_ControlDiagnostic(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: diag_header
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      current_alignment +=
        autoware_auto_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_DiagnosticHeader(
        inner_full_bounded, inner_is_plain, current_alignment);
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: new_trajectory
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: trajectory_source
  {
    size_t array_size = 1;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        256 +
        1;
    }
  }

  // Member: pose_source
  {
    size_t array_size = 1;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        256 +
        1;
    }
  }

  // Member: lateral_error_m
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: longitudinal_error_m
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: velocity_error_mps
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: acceleration_error_mps2
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: yaw_error_rad
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: yaw_rate_error_rps
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  return current_alignment - initial_alignment;
}

static bool _ControlDiagnostic__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const autoware_auto_msgs::msg::ControlDiagnostic *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _ControlDiagnostic__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<autoware_auto_msgs::msg::ControlDiagnostic *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _ControlDiagnostic__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const autoware_auto_msgs::msg::ControlDiagnostic *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _ControlDiagnostic__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_ControlDiagnostic(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _ControlDiagnostic__callbacks = {
  "autoware_auto_msgs::msg",
  "ControlDiagnostic",
  _ControlDiagnostic__cdr_serialize,
  _ControlDiagnostic__cdr_deserialize,
  _ControlDiagnostic__get_serialized_size,
  _ControlDiagnostic__max_serialized_size
};

static rosidl_message_type_support_t _ControlDiagnostic__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_ControlDiagnostic__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace autoware_auto_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_autoware_auto_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<autoware_auto_msgs::msg::ControlDiagnostic>()
{
  return &autoware_auto_msgs::msg::typesupport_fastrtps_cpp::_ControlDiagnostic__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, autoware_auto_msgs, msg, ControlDiagnostic)() {
  return &autoware_auto_msgs::msg::typesupport_fastrtps_cpp::_ControlDiagnostic__handle;
}

#ifdef __cplusplus
}
#endif
